//---------------------------------------------------------------------------
// File: TMainForm.h
//
//  TDx_Sound_Library
//  Example2 - Playing with Sounds
//
// Date: 9th January, 2004
// Author: Darren John Dwyer
// Copyright: (c) 2002-2004 Darren John Dwyer, All Rights Reserved.
//
// Description:
//
// This example shows how to manipulate sounds while they are playing,
// including adjusting the volume, pan and frequency.
//
//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "TDx_Sound.h"
#include "TDx_SoundBuffer.h"
#include "TDSBufferDesc.h"
#include "TDSCaps.h"
#include <vcl\ExtCtrls.hpp>
#include <vcl\FileCtrl.hpp>
//---------------------------------------------------------------------------
#define MAX_DEVICES 256
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:    // IDE-managed Components
    TListBox *DevicesListBox;
    TLabel *Label3;
    TDx_Sound *Dx_Sound1;
    TDx_SoundBuffer *Dx_SoundBuffer1;
    TDSBufferDesc *DSBufferDesc1;
    TBitBtn *ExitButton;
    TPanel *Panel1;
    TLabel *Label23;
    TFileListBox *FileListBox1;
    TLabel *Label2;
    TDriveComboBox *DriveComboBox1;
    TDirectoryListBox *DirectoryListBox1;
    TPanel *BufferPanel;
    TScrollBar *PanScrollBar;
    TLabel *PanLabel;
    TLabel *Label9;
    TLabel *Label10;
    TLabel *Label12;
    TScrollBar *VolumeScrollBar;
    TLabel *Label13;
    TLabel *VolumeLabel;
    TLabel *Label8;
    TLabel *FrequencyLabel;
    TScrollBar *FrequencyScrollBar;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TLabel *Label17;
    TTimer *Timer1;
    TEdit *Edit1;
    TBitBtn *PauseButton;
    TBitBtn *RewindButton;
    TBitBtn *StopButton;
    TBitBtn *PlayButton;
    TBitBtn *ForwardButton;
    TPanel *Panel2;
    TLabel *PlayingLabel;
    TLabel *BufferPosLabel;
    TLabel *BufferSizeLabel;
    TCheckBox *LoopingCheckBox;
    TLabel *NotCreatedLabel;
    TLabel *Label1;
    void __fastcall Dx_SoundBuffer1BufferLost(TObject *Sender);
    void __fastcall Dx_Sound1Destroy(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall DevicesListBoxClick(TObject *Sender);
    void __fastcall PlayButtonClick(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall Dx_SoundBuffer1Create(TObject *Sender);
    void __fastcall PanScrollBarChange(TObject *Sender);
    void __fastcall VolumeScrollBarChange(TObject *Sender);
    void __fastcall FrequencyScrollBarChange(TObject *Sender);
    void __fastcall Dx_SoundBuffer1Destroy(TObject *Sender);
    void __fastcall FileListBox1DblClick(TObject *Sender);
    void __fastcall StopButtonClick(TObject *Sender);
    void __fastcall RewindButtonClick(TObject *Sender);
    void __fastcall ForwardButtonClick(TObject *Sender);
    void __fastcall PauseButtonClick(TObject *Sender);
    void __fastcall ExitButtonClick(TObject *Sender);
    void __fastcall Dx_Sound1Create(TObject *Sender);
    
    
    
    void __fastcall Dx_Sound1DSEnumerate(TObject *Sender, GUID *Guid,
    AnsiString DriverDescription, AnsiString DriverModule, void *Context,
    bool &Finished);
private:    // User declarations
    TStringList*    KnownDevices;
    TStringList*    KnownModules;
    TList*            KnownGuids;

    long            Pan;
    long            Volume;
    dword            Frequency;
    dword            CurrentPlayPos;
    dword            CurrentWritePos;
    bool            Paused;
    
public:        // User declarations
    __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
